Index: /trunk/src/sys/netsmb/smb_subr.h
===================================================================
--- /trunk/src/sys/netsmb/smb_subr.h	(revision 151)
+++ /trunk/src/sys/netsmb/smb_subr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: smb_subr.h,v 1.18 2008/06/24 10:37:19 gmcgarry Exp $	*/
+/*	$NetBSD: smb_subr.h,v 1.18.14.1 2011/05/20 08:11:30 matt Exp $	*/
 
 /*
@@ -110,10 +110,10 @@
 int  smb_proc_intr(struct lwp *);
 char *smb_strdup(const char *s);
-char *smb_strdupin(char *s, int maxlen);
-void *smb_memdupin(void *umem, int len);
+char *smb_strdupin(char *s, size_t maxlen);
+void *smb_memdupin(void *umem, size_t len);
 void smb_strtouni(u_int16_t *dst, const char *src);
 void smb_strfree(char *s);
 void smb_memfree(void *s);
-void *smb_zmalloc(unsigned long size, struct malloc_type *type, int flags);
+void *smb_zmalloc(size_t size, struct malloc_type *type, int flags);
 
 int  smb_encrypt(const u_char *apwd, u_char *C8, u_char *RN);
@@ -121,5 +121,5 @@
 int  smb_maperror(int eclass, int eno);
 int  smb_put_dmem(struct mbchain *mbp, struct smb_vc *vcp,
-	const char *src, int len, int caseopt);
+	const char *src, size_t len, int caseopt);
 int  smb_put_dstring(struct mbchain *mbp, struct smb_vc *vcp,
 	const char *src, int caseopt);
Index: /trunk/src/sys/netsmb/subr_mchain.c
===================================================================
--- /trunk/src/sys/netsmb/subr_mchain.c	(revision 151)
+++ /trunk/src/sys/netsmb/subr_mchain.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: subr_mchain.c,v 1.15 2008/06/24 10:37:19 gmcgarry Exp $	*/
+/*	$NetBSD: subr_mchain.c,v 1.15.14.1 2011/05/20 08:11:30 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: subr_mchain.c,v 1.15 2008/06/24 10:37:19 gmcgarry Exp $");
+__KERNEL_RCSID(0, "$NetBSD: subr_mchain.c,v 1.15.14.1 2011/05/20 08:11:30 matt Exp $");
 
 #include <sys/param.h>
@@ -53,9 +53,7 @@
 #ifdef __NetBSD__
 static struct mbuf *
-m_getm(struct mbuf *m, int len, int how, int type)
+m_getm(struct mbuf *m, size_t len, int how, int type)
 {
         struct mbuf *top, *tail, *mp, *mtail = NULL;
-
-        KASSERT(len >= 0);
 
         mp = m_get(how, type);
@@ -113,5 +111,5 @@
 {
 	struct mbuf *m = m0;
-	int len = 0;
+	size_t len = 0;
 
 	while (m) {
@@ -176,5 +174,5 @@
  */
 void *
-mb_reserve(struct mbchain *mbp, int size)
+mb_reserve(struct mbchain *mbp, size_t size)
 {
 	struct mbuf *m, *mn;
@@ -182,5 +180,5 @@
 
 	if (size > MLEN)
-		panic("mb_reserve: size = %d", size);
+		panic("mb_reserve: size = %zu", size);
 	m = mbp->mb_cur;
 	if (mbp->mb_mleft < size) {
@@ -249,10 +247,11 @@
 
 int
-mb_put_mem(struct mbchain *mbp, const char *source, int size, int type)
+mb_put_mem(struct mbchain *mbp, const char *source, size_t size, int type)
 {
 	struct mbuf *m;
 	char *dst;
 	const char *src;
-	int cplen, error, mleft, count;
+	int error;
+	size_t cplen, mleft, count;
 
 	m = mbp->mb_cur;
@@ -324,7 +323,7 @@
  */
 int
-mb_put_uio(struct mbchain *mbp, struct uio *uiop, int size)
-{
-	long left;
+mb_put_uio(struct mbchain *mbp, struct uio *uiop, size_t size)
+{
+	size_t left;
 	int mtype, error;
 
@@ -515,10 +514,10 @@
 
 int
-md_get_mem(struct mdchain *mdp, void *targetv, int size, int type)
+md_get_mem(struct mdchain *mdp, void *targetv, size_t size, int type)
 {
 	char *target = targetv;
 	struct mbuf *m = mdp->md_cur;
 	int error;
-	u_int count;
+	size_t count;
 	u_char *s;
 
@@ -577,8 +576,8 @@
 
 int
-md_get_uio(struct mdchain *mdp, struct uio *uiop, int size)
+md_get_uio(struct mdchain *mdp, struct uio *uiop, size_t size)
 {
 	char *uiocp;
-	long left;
+	size_t left;
 	int mtype, error;
 
Index: /trunk/src/sys/nfs/nfs_bio.c
===================================================================
--- /trunk/src/sys/nfs/nfs_bio.c	(revision 151)
+++ /trunk/src/sys/nfs/nfs_bio.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: nfs_bio.c,v 1.179.4.1 2008/11/02 23:08:56 snj Exp $	*/
+/*	$NetBSD: nfs_bio.c,v 1.179.4.1.4.1 2011/05/20 08:11:31 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: nfs_bio.c,v 1.179.4.1 2008/11/02 23:08:56 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: nfs_bio.c,v 1.179.4.1.4.1 2011/05/20 08:11:31 matt Exp $");
 
 #include "opt_nfs.h"
@@ -1046,5 +1046,5 @@
 			}
 			mutex_exit(&uobj->vmobjlock);
-			return 0;
+			goto out;
 		} else if (error == NFSERR_STALEWRITEVERF) {
 			nfs_clearcommit(vp->v_mount);
Index: /trunk/src/sys/opencrypto/crypto.c
===================================================================
--- /trunk/src/sys/opencrypto/crypto.c	(revision 151)
+++ /trunk/src/sys/opencrypto/crypto.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: crypto.c,v 1.29.4.1 2008/11/20 03:22:38 snj Exp $ */
+/*	$NetBSD: crypto.c,v 1.29.4.1.4.1 2011/05/20 08:11:31 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/crypto.c,v 1.4.2.5 2003/02/26 00:14:05 sam Exp $	*/
 /*	$OpenBSD: crypto.c,v 1.41 2002/07/17 23:52:38 art Exp $	*/
@@ -54,5 +54,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: crypto.c,v 1.29.4.1 2008/11/20 03:22:38 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: crypto.c,v 1.29.4.1.4.1 2011/05/20 08:11:31 matt Exp $");
 
 #include <sys/param.h>
@@ -339,6 +339,8 @@
 		/* See if all the algorithms are supported. */
 		for (cr = cri; cr; cr = cr->cri_next)
-			if (crypto_drivers[hid].cc_alg[cr->cri_alg] == 0)
+			if (crypto_drivers[hid].cc_alg[cr->cri_alg] == 0) {
+				DPRINTF(("crypto_newsession: alg %d not supported\n", cr->cri_alg));
 				break;
+			}
 
 		if (cr == NULL) {
@@ -715,4 +717,8 @@
 
 	mutex_spin_enter(&crypto_mtx);
+	DPRINTF(("crypto_dispatch: crp %08x, reqid 0x%x, alg %d\n",
+			(uint32_t)crp,
+			crp->crp_reqid,
+			crp->crp_desc->crd_alg));
 
 	cryptostats.cs_ops++;
@@ -963,4 +969,6 @@
 	if (crp == NULL)
 		return;
+	DPRINTF(("crypto_freereq[%d]: crp %p\n",
+			(uint32_t)crp->crp_sid, crp));
 
 	/* sanity check */
@@ -1022,4 +1030,6 @@
 		crypto_tstat(&cryptostats.cs_done, &crp->crp_tstamp);
 #endif
+	DPRINTF(("crypto_done[%d]: crp %08x\n",
+			(uint32_t)crp->crp_sid, (uint32_t)crp));
 
 	/*
@@ -1068,12 +1078,16 @@
 			 * unecessary context switches.
 			 */
+			DPRINTF(("crypto_done[%d]: crp %08x CRYPTO_F_USER\n",
+				(uint32_t)crp->crp_sid, (uint32_t)crp));
 		} else {
 			wasempty = TAILQ_EMPTY(&crp_ret_q);
-			DPRINTF(("crypto_done: queueing %08x\n", (uint32_t)crp));
+			DPRINTF(("crypto_done[%d]: queueing %08x\n",
+					(uint32_t)crp->crp_sid, (uint32_t)crp));
 			crp->crp_flags |= CRYPTO_F_ONRETQ;
 			TAILQ_INSERT_TAIL(&crp_ret_q, crp, crp_next);
 			if (wasempty) {
-				DPRINTF(("crypto_done: waking cryptoret, %08x " \
-					"hit empty queue\n.", (uint32_t)crp));
+				DPRINTF(("crypto_done[%d]: waking cryptoret, crp %08x " \
+					"hit empty queue\n.",
+					(uint32_t)crp->crp_sid, (uint32_t)crp));
 				cv_signal(&cryptoret_cv);
 			}
Index: /trunk/src/sys/opencrypto/cryptodev.c
===================================================================
--- /trunk/src/sys/opencrypto/cryptodev.c	(revision 151)
+++ /trunk/src/sys/opencrypto/cryptodev.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cryptodev.c,v 1.44.8.2 2009/04/04 23:36:28 snj Exp $ */
+/*	$NetBSD: cryptodev.c,v 1.44.8.2.4.1 2011/05/20 08:11:31 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/cryptodev.c,v 1.4.2.4 2003/06/03 00:09:02 sam Exp $	*/
 /*	$OpenBSD: cryptodev.c,v 1.53 2002/07/10 22:21:30 mickey Exp $	*/
@@ -65,5 +65,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cryptodev.c,v 1.44.8.2 2009/04/04 23:36:28 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cryptodev.c,v 1.44.8.2.4.1 2011/05/20 08:11:31 matt Exp $");
 
 #include <sys/param.h>
@@ -88,4 +88,5 @@
 #include "opt_ocf.h"
 #include <opencrypto/cryptodev.h>
+#include <opencrypto/ocryptodev.h>
 #include <opencrypto/xform.h>
 
@@ -95,8 +96,10 @@
 	u_int32_t	ses;
 
-	u_int32_t	cipher;
+	u_int32_t	cipher;		/* note: shares name space in crd_alg */
 	struct enc_xform *txform;
-	u_int32_t	mac;
+	u_int32_t	mac;		/* note: shares name space in crd_alg */
 	struct auth_hash *thash;
+	u_int32_t	comp_alg;	/* note: shares name space in crd_alg */
+	struct comp_algo *tcomp;
 
 	void *		key;
@@ -153,20 +156,15 @@
 };
 
+struct csession *cryptodev_csefind(struct fcrypt *, u_int);
 static struct	csession *csefind(struct fcrypt *, u_int);
 static int	csedelete(struct fcrypt *, struct csession *);
 static struct	csession *cseadd(struct fcrypt *, struct csession *);
 static struct	csession *csecreate(struct fcrypt *, u_int64_t, void *,
-    u_int64_t, void *, u_int64_t, u_int32_t, u_int32_t, struct enc_xform *,
-    struct auth_hash *);
+    u_int64_t, void *, u_int64_t, u_int32_t, u_int32_t, u_int32_t,
+    struct enc_xform *, struct auth_hash *, struct comp_algo *);
 static int	csefree(struct csession *);
 
-static int	cryptodev_op(struct csession *, struct crypt_op *,
-    struct lwp *);
-static int	cryptodev_mop(struct fcrypt *, struct crypt_n_op *, int,
-    struct lwp *);
 static int	cryptodev_key(struct crypt_kop *);
 static int	cryptodev_mkey(struct fcrypt *, struct crypt_n_kop *, int);
-static int	cryptodev_session(struct fcrypt *, struct session_op *);
-static int	cryptodev_msession(struct fcrypt *, struct session_n_op *, int);
 static int	cryptodev_msessionfin(struct fcrypt *, int, u_int32_t *);
 
@@ -180,4 +178,6 @@
     int);
 static int	cryptodev_getstatus(struct fcrypt *, struct crypt_result *);
+
+extern int	ocryptof_ioctl(struct file *, u_long, void *);
 
 /*
@@ -373,16 +373,19 @@
 		break;
 	default:
-		DPRINTF(("invalid ioctl cmd %ld\n", cmd));
-		error = EINVAL;
+		/* Check for backward compatible commands */
+		error = ocryptof_ioctl(fp, cmd, data);
 	}
 	return error;
 }
 
-static int
+int
 cryptodev_op(struct csession *cse, struct crypt_op *cop, struct lwp *l)
 {
 	struct cryptop *crp = NULL;
-	struct cryptodesc *crde = NULL, *crda = NULL;
+	struct cryptodesc *crde = NULL, *crda = NULL, *crdc = NULL;
 	int error;
+	int iov_len = cop->len;
+	int flags=0;
+	int dst_len;	/* copyout size */
 
 	if (cop->len > 256*1024-4)
@@ -392,4 +395,13 @@
 		if (cop->len == 0 || (cop->len % cse->txform->blocksize) != 0)
 			return EINVAL;
+	}
+
+	DPRINTF(("cryptodev_op[%d]: iov_len %d\n", (uint32_t)cse->sid, iov_len));
+	if ((cse->tcomp) && cop->dst_len) {
+		if (iov_len < cop->dst_len) {
+			/* Need larger iov to deal with decompress */
+			iov_len = cop->dst_len;
+		}
+		DPRINTF(("cryptodev_op: iov_len -> %d for decompress\n", iov_len));
 	}
 
@@ -401,26 +413,48 @@
 	UIO_SETUP_SYSSPACE(&cse->uio);
 	memset(&cse->iovec, 0, sizeof(cse->iovec));
-	cse->uio.uio_iov[0].iov_len = cop->len;
-	cse->uio.uio_iov[0].iov_base = kmem_alloc(cop->len, KM_SLEEP);
+
+	/* the iov needs to be big enough to handle the uncompressed
+	 * data.... */
+	cse->uio.uio_iov[0].iov_len = iov_len;
+	cse->uio.uio_iov[0].iov_base = kmem_alloc(iov_len, KM_SLEEP);
 	cse->uio.uio_resid = cse->uio.uio_iov[0].iov_len;
-
-	crp = crypto_getreq((cse->txform != NULL) + (cse->thash != NULL));
+	DPRINTF(("cryptodev_op[%d]: uio.iov_base %p malloced %d bytes\n",
+		(uint32_t)cse->sid, cse->uio.uio_iov[0].iov_base, iov_len));
+
+	crp = crypto_getreq((cse->tcomp != NULL) + (cse->txform != NULL) + (cse->thash != NULL));
 	if (crp == NULL) {
 		error = ENOMEM;
 		goto bail;
 	}
+	DPRINTF(("cryptodev_op[%d]: crp %p\n", (uint32_t)cse->sid, crp));
+
+	/* crds are always ordered tcomp, thash, then txform */
+	/* with optional missing links */
+
+	/* XXX: If we're going to compress then hash or encrypt, we need
+	 * to be able to pass on the new size of the data.
+	 */
+
+	if (cse->tcomp) {
+		crdc = crp->crp_desc;
+	}
 
 	if (cse->thash) {
-		crda = crp->crp_desc;
+		crda = crdc ? crdc->crd_next : crp->crp_desc;
 		if (cse->txform && crda)
 			crde = crda->crd_next;
 	} else {
-		if (cse->txform)
-			crde = crp->crp_desc;
-		else {
+		if (cse->txform) {
+			crde = crdc ? crdc->crd_next : crp->crp_desc;
+		} else if (!cse->tcomp) {
 			error = EINVAL;
 			goto bail;
 		}
 	}
+
+	DPRINTF(("ocf[%d]: iov_len %d, cop->len %d\n",
+			(uint32_t)cse->sid,
+			cse->uio.uio_iov[0].iov_len, 
+			cop->len));
 
 	if ((error = copyin(cop->src, cse->uio.uio_iov[0].iov_base, cop->len)))
@@ -430,4 +464,29 @@
 	}
 
+	if (crdc) {
+		switch (cop->op) {
+		case COP_COMP:
+			crdc->crd_flags |= CRD_F_COMP;
+			break;
+		case COP_DECOMP:
+			crdc->crd_flags &= ~CRD_F_COMP;
+			break;
+		default:
+			break;
+		}
+		/* more data to follow? */
+		if (cop->flags & COP_F_MORE) {
+			flags |= CRYPTO_F_MORE;
+		}
+		crdc->crd_len = cop->len;
+		crdc->crd_inject = 0;
+
+		crdc->crd_alg = cse->comp_alg;
+		crdc->crd_key = NULL;
+		crdc->crd_klen = 0;
+		DPRINTF(("cryptodev_op[%d]: crdc setup for comp_alg %d.\n",
+					(uint32_t)cse->sid, crdc->crd_alg));
+	}
+
 	if (crda) {
 		crda->crd_skip = 0;
@@ -438,11 +497,18 @@
 		crda->crd_key = cse->mackey;
 		crda->crd_klen = cse->mackeylen * 8;
+		DPRINTF(("cryptodev_op: crda setup for mac %d.\n", crda->crd_alg));
 	}
 
 	if (crde) {
-		if (cop->op == COP_ENCRYPT)
+		switch (cop->op) {
+		case COP_ENCRYPT:
 			crde->crd_flags |= CRD_F_ENCRYPT;
-		else
+			break;
+		case COP_DECRYPT:
 			crde->crd_flags &= ~CRD_F_ENCRYPT;
+			break;
+		default:
+			break;
+		}
 		crde->crd_len = cop->len;
 		crde->crd_inject = 0;
@@ -451,5 +517,7 @@
 		crde->crd_key = cse->key;
 		crde->crd_klen = cse->keylen * 8;
-	}
+		DPRINTF(("cryptodev_op: crde setup for cipher %d.\n", crde->crd_alg));
+	}
+
 
 	crp->crp_ilen = cop->len;
@@ -459,5 +527,6 @@
 	 * delayed or is not completed immediately the flag is removed.
 	 */
-	crp->crp_flags = CRYPTO_F_IOV | (cop->flags & COP_F_BATCH) | CRYPTO_F_USER;
+	crp->crp_flags = CRYPTO_F_IOV | (cop->flags & COP_F_BATCH) | CRYPTO_F_USER |
+			flags;
 	crp->crp_buf = (void *)&cse->uio;
 	crp->crp_callback = (int (*) (struct cryptop *)) cryptodev_cb;
@@ -517,5 +586,5 @@
 	 * If the request was going to be completed by the
 	 * ioctl thread then it would have been done by now.
-	 * Remove the F_USER flag it so crypto_done() is not confused
+	 * Remove the F_USER flag so crypto_done() is not confused
 	 * if the crypto device calls it after this point.
 	 */
@@ -538,6 +607,7 @@
 
 	while (!(crp->crp_flags & CRYPTO_F_DONE)) {
-		DPRINTF(("cryptodev_op: sleeping on cv %08x for crp %08x\n", \
-		    (uint32_t)&crp->crp_cv, (uint32_t)crp));
+		DPRINTF(("cryptodev_op[%d]: sleeping on cv %08x for crp %08x\n",
+			(uint32_t)cse->sid, (uint32_t)&crp->crp_cv,
+			(uint32_t)crp));
 		cv_wait(&crp->crp_cv, &crypto_mtx);	/* XXX cv_wait_sig? */
 	}
@@ -563,6 +633,16 @@
 	}
 
+	dst_len = crp->crp_ilen;
+	/* let the user know how much data was returned */
+	if (crp->crp_olen) {
+		dst_len = cop->dst_len = crp->crp_olen;
+	}
+	crp->len = dst_len;
+
+	if (cop->dst) {
+		DPRINTF(("cryptodev_op: copyout %d bytes to %p\n", dst_len, cop->dst));
+	}
 	if (cop->dst &&
-	    (error = copyout(cse->uio.uio_iov[0].iov_base, cop->dst, cop->len)))
+	    (error = copyout(cse->uio.uio_iov[0].iov_base, cop->dst, dst_len)))
 	{
 		DPRINTF(("cryptodev_op: copyout error %d\n", error));
@@ -576,11 +656,12 @@
 	}
 
+
 bail:
 	if (crp) {
 		crypto_freereq(crp);
 	}
-	if (cse->uio.uio_iov[0].iov_base)
-		kmem_free(cse->uio.uio_iov[0].iov_base,
-		    cse->uio.uio_iov[0].iov_len);
+	if (cse->uio.uio_iov[0].iov_base) {
+		kmem_free(cse->uio.uio_iov[0].iov_base,iov_len);
+	}
 
 	return error;
@@ -816,4 +897,10 @@
 }
 
+/* needed for compatibility module */
+struct	csession *cryptodev_csefind(struct fcrypt *fcr, u_int ses)
+{
+	return csefind(fcr, ses);
+}
+
 /* csefind: call with crypto_mtx held. */
 static struct csession *
@@ -863,5 +950,6 @@
 csecreate(struct fcrypt *fcr, u_int64_t sid, void *key, u_int64_t keylen,
     void *mackey, u_int64_t mackeylen, u_int32_t cipher, u_int32_t mac,
-    struct enc_xform *txform, struct auth_hash *thash)
+    u_int32_t comp_alg, struct enc_xform *txform, struct auth_hash *thash,
+    struct comp_algo *tcomp)
 {
 	struct csession *cse;
@@ -878,6 +966,8 @@
 	cse->cipher = cipher;
 	cse->mac = mac;
+	cse->comp_alg = comp_alg;
 	cse->txform = txform;
 	cse->thash = thash;
+	cse->tcomp = tcomp;
 	cse->error = 0;
 	if (cseadd(fcr, cse))
@@ -968,5 +1058,5 @@
 };
 
-static int 
+int 
 cryptodev_mop(struct fcrypt *fcr, 
               struct crypt_n_op * cnop,
@@ -974,7 +1064,9 @@
 {
 	struct cryptop *crp = NULL;
-	struct cryptodesc *crde = NULL, *crda = NULL;
+	struct cryptodesc *crde = NULL, *crda = NULL, *crdc = NULL;
 	int req, error=0;
 	struct csession *cse;
+	int flags=0;
+	int iov_len;
 
 	for (req = 0; req < count; req++) {
@@ -1003,8 +1095,19 @@
 
 		crp = crypto_getreq((cse->txform != NULL) +
-		    (cse->thash != NULL));
+				    (cse->thash != NULL) +
+				    (cse->tcomp != NULL));
 		if (crp == NULL) {
 			cnop[req].status = ENOMEM;
 			goto bail;
+		}
+
+		iov_len = cnop[req].len;
+		/* got a compression/decompression max size? */
+		if ((cse->tcomp) && cnop[req].dst_len) {
+			if (iov_len < cnop[req].dst_len) {
+				/* Need larger iov to deal with decompress */
+				iov_len = cnop[req].dst_len;
+			}
+			DPRINTF(("cryptodev_mop: iov_len -> %d for decompress\n", iov_len));
 		}
 
@@ -1016,19 +1119,23 @@
 		UIO_SETUP_SYSSPACE(&crp->uio);
 		memset(&crp->iovec, 0, sizeof(crp->iovec));
-		crp->uio.uio_iov[0].iov_len = cnop[req].len;
-		crp->uio.uio_iov[0].iov_base = kmem_alloc(cnop[req].len,
-		    KM_SLEEP);
+		crp->uio.uio_iov[0].iov_len = iov_len;
+		DPRINTF(("cryptodev_mop: kmem_alloc(%d) for iov \n", iov_len));
+		crp->uio.uio_iov[0].iov_base = kmem_alloc(iov_len, KM_SLEEP);
 		crp->uio.uio_resid = crp->uio.uio_iov[0].iov_len;
 
+		if (cse->tcomp) {
+			crdc = crp->crp_desc;
+		}
+
 		if (cse->thash) {
-			crda = crp->crp_desc;
+			crda = crdc ? crdc->crd_next : crp->crp_desc;
 			if (cse->txform && crda)
 				crde = crda->crd_next;
 		} else {
-			if (cse->txform)
-				crde = crp->crp_desc;
-			else {
-				cnop[req].status = EINVAL;
-				goto bail;	
+			if (cse->txform) {
+				crde = crdc ? crdc->crd_next : crp->crp_desc;
+			} else if (!cse->tcomp) {
+				error = EINVAL;
+				goto bail;
 			}
 		}
@@ -1038,4 +1145,31 @@
 			cnop[req].status = EINVAL;
 			goto bail;
+		}
+
+		if (crdc) {
+			switch (cnop[req].op) {
+			case COP_COMP:
+				crdc->crd_flags |= CRD_F_COMP;
+				break;
+			case COP_DECOMP:
+				crdc->crd_flags &= ~CRD_F_COMP;
+				break;
+			default:
+				break;
+			}
+			/* more data to follow? */
+			if (cnop[req].flags & COP_F_MORE) {
+				flags |= CRYPTO_F_MORE;
+			}
+			crdc->crd_len = cnop[req].len;
+			crdc->crd_inject = 0;
+
+			crdc->crd_alg = cse->comp_alg;
+			crdc->crd_key = NULL;
+			crdc->crd_klen = 0;
+			DPRINTF(("cryptodev_mop[%d]: crdc setup for comp_alg %d"
+				 " len %d.\n",
+				(uint32_t)cse->sid, crdc->crd_alg,
+				crdc->crd_len));
 		}
 	
@@ -1077,5 +1211,5 @@
 		crp->crp_ilen = cnop[req].len;
 		crp->crp_flags = CRYPTO_F_IOV | CRYPTO_F_CBIMM |
-		    (cnop[req].flags & COP_F_BATCH);
+		    (cnop[req].flags & COP_F_BATCH) | flags;
 		crp->crp_buf = (void *)&crp->uio;
 		crp->crp_callback = (int (*) (struct cryptop *)) cryptodev_mcb;
@@ -1084,7 +1218,9 @@
 		crp->fcrp = fcr;
 		crp->dst = cnop[req].dst;
-		/* we can use the crp_ilen in cryptop(crp) for this */
-		crp->len = cnop[req].len;
+		crp->len = cnop[req].len; /* input len, iov may be larger */
 		crp->mac = cnop[req].mac;
+		DPRINTF(("cryptodev_mop: iov_base %p dst %p len %d mac %p\n",
+			    crp->uio.uio_iov[0].iov_base, crp->dst, crp->len,
+			    crp->mac));
 
 		if (cnop[req].iv) {
@@ -1151,9 +1287,9 @@
 		if (cnop[req].status) {
 			if (crp) {
+				if (crp->uio.uio_iov[0].iov_base) {
+					kmem_free(crp->uio.uio_iov[0].iov_base,
+					    crp->uio.uio_iov[0].iov_len);
+				}
 				crypto_freereq(crp);
-				if(cse->uio.uio_iov[0].iov_base) {
-					kmem_free(cse->uio.uio_iov[0].iov_base,
-					    cse->uio.uio_iov[0].iov_len);
-				}
 			}
 			error = 0;
@@ -1304,14 +1440,19 @@
 }
 
-static int
+int
 cryptodev_session(struct fcrypt *fcr, struct session_op *sop) 
 {
 	struct cryptoini cria, crie;
+	struct cryptoini cric;		/* compressor */
+	struct cryptoini *crihead = NULL;
 	struct enc_xform *txform = NULL;
 	struct auth_hash *thash = NULL;
+	struct comp_algo *tcomp = NULL;
 	struct csession *cse;
 	u_int64_t sid;
 	int error = 0;
 
+	DPRINTF(("cryptodev_session() cipher=%d, mac=%d\n", sop->cipher, sop->mac));
+
 	/* XXX there must be a way to not embed the list of xforms here */
 	switch (sop->cipher) {
@@ -1329,4 +1470,5 @@
 	case CRYPTO_CAST_CBC:
 		txform = &enc_xform_cast5;
+		break;
 	case CRYPTO_SKIPJACK_CBC:
 		txform = &enc_xform_skipjack;
@@ -1343,4 +1485,19 @@
 	default:
 		DPRINTF(("Invalid cipher %d\n", sop->cipher));
+		return EINVAL;
+	}
+
+	switch (sop->comp_alg) {
+	case 0:
+		break;
+	case CRYPTO_DEFLATE_COMP:
+		tcomp = &comp_algo_deflate;
+		break;
+	case CRYPTO_GZIP_COMP:
+		tcomp = &comp_algo_gzip;
+		DPRINTF(("cryptodev_session() tcomp for GZIP\n"));
+		break;
+	default:
+		DPRINTF(("Invalid compression alg %d\n", sop->comp_alg));
 		return EINVAL;
 	}
@@ -1396,4 +1553,18 @@
 	memset(&crie, 0, sizeof(crie));
 	memset(&cria, 0, sizeof(cria));
+	memset(&cric, 0, sizeof(cric));
+
+	if (tcomp) {
+		cric.cri_alg = tcomp->type;
+		cric.cri_klen = 0;
+		DPRINTF(("tcomp->type = %d\n", tcomp->type));
+
+		crihead = &cric;
+		if (thash) {
+			cric.cri_next = &cria;
+		} else if (txform) {
+			cric.cri_next = &crie;
+		}
+	}
 
 	if (txform) {
@@ -1411,7 +1582,8 @@
 		if ((error = copyin(sop->key, crie.cri_key, crie.cri_klen / 8)))
 			goto bail;
-		if (thash)
-			crie.cri_next = &cria;	/* XXX forces enc then hash? */
-	}
+		if (!crihead) {
+			crihead = &crie;
+		}
+	} 
 
 	if (thash) {
@@ -1432,13 +1604,19 @@
 			}
 		}
-	}
+		if (txform)
+			cria.cri_next = &crie;	/* XXX forces enc then hash? */
+		if (!crihead) {
+			crihead = &cria;
+		}
+	}
+
 	/* crypto_newsession requires that we hold the mutex. */
 	mutex_spin_enter(&crypto_mtx);
-	error = crypto_newsession(&sid, (txform ? &crie : &cria),
-	    crypto_devallowsoft);
+	error = crypto_newsession(&sid, crihead, crypto_devallowsoft);
 	if (!error) {
+		DPRINTF(("cyrptodev_session: got session %d\n", (uint32_t)sid));
 		cse = csecreate(fcr, sid, crie.cri_key, crie.cri_klen,
-		    cria.cri_key, cria.cri_klen, sop->cipher, sop->mac,
-		    txform, thash);
+		    cria.cri_key, cria.cri_klen, (txform ? sop->cipher : 0), sop->mac,
+		    (tcomp ? sop->comp_alg : 0), txform, thash, tcomp);
 		if (cse != NULL) {
 			sop->ses = cse->ses;
@@ -1467,5 +1645,5 @@
 }
 
-static int
+int
 cryptodev_msession(struct fcrypt *fcr, struct session_n_op *sn_ops,
 		   int count)
@@ -1522,11 +1700,10 @@
 	int completed=0;
 
-	/* On stack so nobody else can grab them -- no locking */
-	SLIST_HEAD(, cryptop) crp_delfree_l =
-	    SLIST_HEAD_INITIALIZER(crp_delfree_l);
-	SLIST_HEAD(, cryptkop) krp_delfree_l =
-	    SLIST_HEAD_INITIALIZER(krp_delfree_l);
-
-	mutex_spin_enter(&crypto_mtx);
+	/* On queue so nobody else can grab them
+	 * and copyout can be delayed-- no locking */
+	TAILQ_HEAD(, cryptop) crp_delfree_q = 
+		TAILQ_HEAD_INITIALIZER(crp_delfree_q);
+	TAILQ_HEAD(, cryptkop) krp_delfree_q = 
+		TAILQ_HEAD_INITIALIZER(krp_delfree_q);
 
 	/* at this point we do not know which response user is requesting for 
@@ -1534,17 +1711,48 @@
 	 * count is 2 then 1 from symmetric and 1 from asymmetric queue and 
 	 * if 3 then 2 symmetric and 1 asymmetric and so on */
-	for(; req < count ;) {
+
+	/* pull off a list of requests while protected from changes */
+	mutex_spin_enter(&crypto_mtx);
+	while (req < count) {
 		crp = TAILQ_FIRST(&fcr->crp_ret_mq);
-		if(crp) {
+		if (crp) {
+			TAILQ_REMOVE(&fcr->crp_ret_mq, crp, crp_next);
+			TAILQ_INSERT_TAIL(&crp_delfree_q, crp, crp_next);
+			cse = (struct csession *)crp->crp_opaque;
+
+			/* see if the session is still valid */
+			cse = csefind(fcr, cse->ses);
+			if (cse != NULL) {
+				crypt_res[req].status = 0;
+			} else {
+				DPRINTF(("csefind failed\n"));
+				crypt_res[req].status = EINVAL;
+			}
+			req++;
+		}
+		if(req < count) {
+			crypt_res[req].status = 0;
+			krp = TAILQ_FIRST(&fcr->crp_ret_mkq);
+			if (krp) {
+				TAILQ_REMOVE(&fcr->crp_ret_mkq, krp, krp_next);
+				TAILQ_INSERT_TAIL(&krp_delfree_q, krp, krp_next);
+			req++;
+			}
+		}
+	}
+	mutex_spin_exit(&crypto_mtx);
+
+	/* now do all the work outside the mutex */
+	for(req=0; req < count ;) {
+		crp = TAILQ_FIRST(&crp_delfree_q);
+		if (crp) {
+			if (crypt_res[req].status != 0) {
+				/* csefind failed during collection */
+				goto bail;
+			}
 			cse = (struct csession *)crp->crp_opaque;
 			crypt_res[req].reqid = crp->crp_reqid;
 			crypt_res[req].opaque = crp->crp_usropaque;
 			completed++;
-			cse = csefind(fcr, cse->ses);
-			if (cse == NULL) {
-				DPRINTF(("csefind failed\n"));
-				crypt_res[req].status = EINVAL;
-				goto bail;
-			}
 			
 			if (crp->crp_etype != 0) {
@@ -1567,13 +1775,15 @@
 			    cse->thash->authsize)))
 				goto bail;
+
 bail:
-			TAILQ_REMOVE(&fcr->crp_ret_mq, crp, crp_next);
-			SLIST_INSERT_HEAD(&crp_delfree_l, crp,
-			    crp_qun.crp_lnext);
+			TAILQ_REMOVE(&crp_delfree_q, crp, crp_next);
+			kmem_free(crp->uio.uio_iov[0].iov_base,
+			    crp->uio.uio_iov[0].iov_len);
+			crypto_freereq(crp);
 			req++;
 		}
 
-		if(req < count) {
-			krp = TAILQ_FIRST(&fcr->crp_ret_mkq);
+		if (req < count) {
+			krp = TAILQ_FIRST(&krp_delfree_q);
 			if (krp) {
 				crypt_res[req].reqid = krp->krp_reqid;
@@ -1607,38 +1817,23 @@
 				}
 fail:
-				TAILQ_REMOVE(&fcr->crp_ret_mkq, krp, krp_next);
+				TAILQ_REMOVE(&krp_delfree_q, krp, krp_next);
 				/* not sure what to do for this */
 				/* kop[req].crk_status = krp->krp_status; */ 
-				SLIST_INSERT_HEAD(&krp_delfree_l, krp,
-				    krp_qun.krp_lnext);
-			}
-			req++;
-		}
-	}
-	mutex_spin_exit(&crypto_mtx);
-
-	while(!SLIST_EMPTY(&crp_delfree_l)) {
-		crp = SLIST_FIRST(&crp_delfree_l);
-		SLIST_REMOVE_HEAD(&crp_delfree_l, crp_qun.crp_lnext);
-		kmem_free(crp->uio.uio_iov[0].iov_base,
-		    crp->uio.uio_iov[0].iov_len);
-		crypto_freereq(crp);
-	}
-	
-	while(!SLIST_EMPTY(&krp_delfree_l)) {
-		krp = SLIST_FIRST(&krp_delfree_l);
-		for (i = 0; i < CRK_MAXPARAM; i++) {
-			struct crparam *kp = &(krp->krp_param[i]);
-			if (kp->crp_p) {
-				size = (kp->crp_nbits + 7) / 8;
-				KASSERT(size > 0);
-				(void)memset(kp->crp_p, 0, size);
-				kmem_free(kp->crp_p, size);
-			}
-		}
-		SLIST_REMOVE_HEAD(&krp_delfree_l, krp_qun.krp_lnext);
-		cv_destroy(&krp->krp_cv);
-		pool_put(&cryptkop_pool, krp);
-	}
+				for (i = 0; i < CRK_MAXPARAM; i++) {
+					struct crparam *kp = &(krp->krp_param[i]);
+					if (kp->crp_p) {
+						size = (kp->crp_nbits + 7) / 8;
+						KASSERT(size > 0);
+						(void)memset(kp->crp_p, 0, size);
+						kmem_free(kp->crp_p, size);
+					}
+				}
+				cv_destroy(&krp->krp_cv);
+				pool_put(&cryptkop_pool, krp);
+				req++;
+			}
+		}
+	}
+
 	return completed;	
 }
Index: /trunk/src/sys/opencrypto/cryptodev.h
===================================================================
--- /trunk/src/sys/opencrypto/cryptodev.h	(revision 151)
+++ /trunk/src/sys/opencrypto/cryptodev.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cryptodev.h,v 1.14.10.1 2008/11/20 03:22:38 snj Exp $ */
+/*	$NetBSD: cryptodev.h,v 1.14.10.1.4.1 2011/05/20 08:11:31 matt Exp $ */
 /*	$FreeBSD: src/sys/opencrypto/cryptodev.h,v 1.2.2.6 2003/07/02 17:04:50 sam Exp $	*/
 /*	$OpenBSD: cryptodev.h,v 1.33 2002/07/17 23:52:39 art Exp $	*/
@@ -132,5 +132,6 @@
 #define CRYPTO_SHA1_HMAC_96	20
 #define CRYPTO_RIPEMD160_HMAC_96	21
-#define CRYPTO_ALGORITHM_MAX	22 /* Keep updated - see below */
+#define CRYPTO_GZIP_COMP	22 /* Deflate compression algorithm */
+#define CRYPTO_ALGORITHM_MAX	23 /* Keep updated - see below */
 
 /* Algorithm flags */
@@ -142,4 +143,5 @@
 	u_int32_t	cipher;		/* ie. CRYPTO_DES_CBC */
 	u_int32_t	mac;		/* ie. CRYPTO_MD5_HMAC */
+	u_int32_t	comp_alg;	/* ie. CRYPTO_GZIP_COMP */
 
 	u_int32_t	keylen;		/* cipher key */
@@ -156,4 +158,5 @@
 	u_int32_t	cipher;		/* ie. CRYPTO_DES_CBC */
 	u_int32_t	mac;		/* ie. CRYPTO_MD5_HMAC */
+	u_int32_t	comp_alg;	/* ie. CRYPTO_GZIP_COMP */
 
 	u_int32_t	keylen;		/* cipher key */
@@ -171,10 +174,13 @@
 #define COP_ENCRYPT	1
 #define COP_DECRYPT	2
+#define COP_COMP	3
+#define COP_DECOMP	4
 	u_int16_t	flags;
 #define	COP_F_BATCH 	0x0008		/* Dispatch as quickly as possible */
-	u_int		len;
+	u_int		len;		/* src len */
 	void *		src, *dst;	/* become iov[] inside kernel */
 	void *		mac;		/* must be big enough for chosen MAC */
 	void *		iv;
+	u_int		dst_len;	/* dst len if not 0 */
 };
 
@@ -201,5 +207,6 @@
 	u_int16_t	flags;
 #define COP_F_BATCH	0x0008		/* Dispatch as quickly as possible */
-	u_int		len;
+#define COP_F_MORE	0x0010		/* more data to follow */
+	u_int		len;		/* src len */
 
 	u_int32_t	reqid;		/* request id */
@@ -214,4 +221,5 @@
 	void *		mac;		/* must be big enough for chosen MAC */
 	void *		iv;
+	u_int		dst_len;	/* dst len if not 0 */
 };
 
@@ -341,14 +349,15 @@
 
 /* the following are done against the cloned descriptor */
-#define	CIOCGSESSION	_IOWR('c', 101, struct session_op)
 #define	CIOCFSESSION	_IOW('c', 102, u_int32_t)
-#define CIOCCRYPT	_IOWR('c', 103, struct crypt_op)
 #define CIOCKEY		_IOWR('c', 104, struct crypt_kop)
-#define	CIOCNGSESSION	_IOWR('c', 106, struct crypt_sgop)
-#define CIOCNCRYPTM	_IOWR('c', 107, struct crypt_mop)
 #define CIOCNFKEYM	_IOWR('c', 108, struct crypt_mkop)
 #define CIOCNFSESSION	_IOW('c', 109, struct crypt_sfop)
 #define CIOCNCRYPTRETM	_IOWR('c', 110, struct cryptret)
 #define CIOCNCRYPTRET	_IOWR('c', 111, struct crypt_result)
+
+#define	CIOCGSESSION	_IOWR('c', 112, struct session_op)
+#define	CIOCNGSESSION	_IOWR('c', 113, struct crypt_sgop)
+#define CIOCCRYPT	_IOWR('c', 114, struct crypt_op)
+#define CIOCNCRYPTM	_IOWR('c', 115, struct crypt_mop)
 
 #define CIOCASYMFEAT	_IOR('c', 105, u_int32_t)
@@ -405,5 +414,5 @@
 #define	CRD_F_IV_EXPLICIT	0x04	/* IV explicitly provided */
 #define	CRD_F_DSA_SHA_NEEDED	0x08	/* Compute SHA-1 of buffer for DSA */
-#define CRD_F_COMP		0x0f    /* Set when doing compression */
+#define CRD_F_COMP		0x10    /* Set when doing compression */
 
 	struct cryptoini	CRD_INI; /* Initialization/context data */
@@ -419,9 +428,5 @@
 /* Structure describing complete operation */
 struct cryptop {
-	union {
-		TAILQ_ENTRY(cryptop) crp_tnext;
-		SLIST_ENTRY(cryptop) crp_lnext;
-	}		crp_qun;
-#define	crp_next crp_qun.crp_tnext	/* XXX compat */
+	TAILQ_ENTRY(cryptop) crp_next;
 	u_int64_t	crp_sid;	/* Session ID */
 	
@@ -453,4 +458,5 @@
 #define	CRYPTO_F_ONRETQ		0x0080	/* Request is on return queue */
 #define	CRYPTO_F_USER		0x0100	/* Request is in user context */
+#define	CRYPTO_F_MORE		0x0200	/* more data to follow */
 
 	void *		crp_buf;	/* Data to be processed */
@@ -472,4 +478,5 @@
 	struct iovec	iovec[1];
 	struct uio	uio;
+	uint32_t	magic;
 };
 
@@ -487,9 +494,5 @@
 
 struct cryptkop {
-	union {
-		TAILQ_ENTRY(cryptkop) krp_tnext;
-                SLIST_ENTRY(cryptkop) krp_lnext;
-        }               krp_qun;
-#define krp_next krp_qun.krp_tnext	/* XXX compat */
+	TAILQ_ENTRY(cryptkop) krp_next;
 
 	u_int32_t	krp_reqid;	/* request id */
